<?php

/*
	File: $Id: function_cats.php,v 1.1.2.4 2007/02/24 23:35:52 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005
	Author: surgeon <sursoft@nm.ru> http://skillz.ru

    categories admin funcs
*/

// [funcs]

function skillz_get_cats () {
	$core = &core_c::get_instance();
    $sql = "SELECT id, parent_id, name, title, auth_view, auth_modify, auth_create FROM ".CMS_CATS_TABLE." WHERE cat_type = " .CORE_CAT_PAGES. " ORDER BY parent_id, n_order;";
	$result = $core->db->sql_query($sql);
	$cats = array();
	while( $row = $core->db->sql_fetchrow($result) ) {
	    $cats[$row['id']]=$row; //[$row['parent_id']]
	}
    return $cats;
}

function skillz_assign_cats_tpl_vars ($row, $_level, $class_='row1') {

	$core = &core_c::get_instance();

	$core->template->assign_block_vars('cats',array(
	        'id' => $row['id'],
            'parent_id' => $row['parent_id'],
	        'name' => $row['name'],
	        'title' => $row['title'],
	        'count' => $row['count'],
	        'order' => $row['n_order'],
	        'spacing' => str_repeat('&nbsp;',$_level*3) . (($row['parent_id']!=0) ? '&bull; ' : ' '),
            'spacing_px' => $_level*10,
            'class' => $class_,
            'row_class' => ($_level==0) ? 'bodrer-bottom:1px gray solid' : '',
            'auth_create' =>  admin_make_auth_html_list('', $row['auth_create'],1),
            'auth_view' =>  admin_make_auth_html_list('', $row['auth_view'],1),
            'auth_mod' =>  admin_make_auth_html_list('', $row['auth_modify'],1),
            'vis' => ($row['visible']=='1') ? '<span style="color:red;font-weight:bold">&bull;</span>' : '',
            'is_url' => ($row['is_url']=='1') ? '<a href="'.append_sid('index.php?gcat='.$row['id']).'" target="_blank"><span style="color:green;font-weight:bold">&bull;</span></a>' : '',
	    ));
}

function skillz_fetch_cats_by_parentid($parent_id, $cat_type=CORE_CAT_PAGES) {

	GLOBAL $core;
	$rowset = array();
    $sql = "SELECT * FROM ".CMS_CATS_TABLE." WHERE parent_id = '{$parent_id}' AND cat_type = '" .$cat_type. "' ORDER BY n_order;";
	$result = $core->db->sql_query($sql);

	while( $row = $core->db->sql_fetchrow($result) ) {
    	$rowset[$row['id']] = $row;
	}
    return $rowset;
}

// branch dump

function skillz_print_tree_branch($tree, $id, $lvl = FALSE, $class_='row1') {

	GLOBAL $core;

	// $core->dprint(' ----------- (' . $id . ' / ' . $lvl);

	$lvl++;

	while (list($k,$row)=each($tree[$lvl])) {

        if ($row['parent_id']==$id) {
        	// --> output
	        // $core->dprint(str_repeat('-',$lvl*2) . ' ' . $row['id'] .' /' . $row['name']);
            skillz_assign_cats_tpl_vars ($row, $lvl);
            // <--

	        skillz_print_tree_branch($tree,$row['id'],$lvl,$class_);
	    }


	}
}

// full tree

function skillz_print_tree($tree) {

	GLOBAL $core;
	//0-lvl
    $n_level=0;
    $class_ = 'row1';

    while (list($k,$p_cat)=each($tree[$n_level])) {

    	// --> output
    	// $core->cprint('[b][color=green]'.$p_cat['id'] . ' / ' .$p_cat['name'].'[/color][/b]');

        skillz_assign_cats_tpl_vars ($p_cat, 0, 'row3');
        // <--
        skillz_print_tree_branch($tree,$p_cat['id'],$n_level,$class_);
        $class_ = ($class_=='row1') ? 'row2' : 'row1';

    }

}

// [/funcs]



//


function skillz_enum_cats () {

    $tree = array();
	$i = 0;
	$i_next = 0;

	// fetch 0-level cats
	$is_fuckin_true = TRUE;
	$n_level = $n_next_level = 0;
	$tmp_buff = array();
	$tree[$n_level] = skillz_fetch_cats_by_parentid(0);

	while ($is_fuckin_true) {

	    $n_next_level = $n_level + 1;
	    $tree[$n_next_level] = array();

	    while (list($k,$p_cat)=each($tree[$n_level])) {
	         // $core->dprint(str_repeat('+',$n_level). $p_cat['id']);
	         $tmp_buff = skillz_fetch_cats_by_parentid($p_cat['id']);
	         if (!empty($tmp_buff))
	             $tree[$n_next_level] = array_merge($tree[$n_next_level], $tmp_buff);
	    }

	    if (empty($tree[$n_next_level])) $is_fuckin_true = FALSE; // aka break

	    $n_level++;
	}
    return $tree;
}


/*
	build select box with cats filled
*/

function skillz_make_sbox_elm($row, $lvl=FALSE, $preselect=FALSE) {

   //core_c::cprint( $row['id'] . '  : '.$preselect );
	$selected = ($preselect==$row['id']) ? 'selected' : '';
	$s_class = ($lvl==0) ? 'style="color:green;font-weight:bold"' : '';
	return "<option value='{$row['id']}' {$selected} {$s_class}>".str_repeat('&nbsp;',$lvl*2) . ' [' . $row['id'] .'] ' . ($row['id']==0?'':$row['title'])."</option>\n";

}

// branch dump

function skillz_make_tree_branch_sbox($tree, $id, $lvl = FALSE, &$sbox, $preselect) {
	$lvl++;
	while (list($k,$row)=each($tree[$lvl])) {
        if ($row['parent_id']==$id) {
            //$sbox [] = str_repeat(' ',$lvl*2) . ' [' . $row['id'] .'] ' . $row['name'];
            $sbox [] =  skillz_make_sbox_elm($row,$lvl,$preselect);
	        skillz_make_tree_branch_sbox($tree,$row['id'],$lvl,$sbox,$preselect);
	    }
	}
}

//
// full tree SELECT BOX
//

function skillz_make_tree_sbox($tree, $select_name = 'catsbox', $preselect = -1, $predisable = FALSE, $raw_cats = FALSE) {

	GLOBAL $core;
    $sbox = array();
	//0-lvl
    $n_level=0;

    if (empty($tree)) return 'undefined';

    // disabled
    if (empty($select_name) || $predisable) {
        return ((isset($raw_cats[$preselect])) ? ('['.$raw_cats[$preselect]['id'].'] '.$raw_cats[$preselect]['name']) : 'undefined');
    }


    $sbox[]='<select name="'.$select_name.'" class="post">';

    //add fake root-dir
    $row = array('id'=>'0','name'=>'');
    $sbox [] = skillz_make_sbox_elm($row,0);

    reset($tree);
    while (list($k,$row)=each($tree[$n_level])) {
       	$sbox [] = skillz_make_sbox_elm($row,0,$preselect);
        skillz_make_tree_branch_sbox($tree,$row['id'],$n_level,$sbox,$preselect);
    }

    $sbox [] = "</select>";

    $retsz = implode("\n",$sbox);

    return $retsz;
}
