<?php
  
/*
	File: $Id: cache.php,v 1.1.2.2 2007/02/24 22:47:29 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005
	Author: surgeon <sursoft@nm.ru> http://skillz.ru
*/

class cache_c {
    
    var $enabled = false;   // module enabled?
    var $needupdate = false;
    var $upd_hook = false;  // ,    
    var $ident;
    var $config;
    
    var $id;
    var $page_data = array();
    var $data = array(); 
    
    var $buffer; // last saved
    
                 /*
                     
                    ['type']{[s_type]}[id] => data
                */
        
    // item
    function item_check($type,$id, $s_type=false) {     
    
      //  core_c::cprint('[cache] check '.$type.' : '.$s_type.' : '.$id);
        
        if ($id===false && $s_type!==false) {
            // check without id (3lvl)
            return (isset($this->data[$type][$s_type]));
        }
               
        return (($s_type) ? (isset($this->data[$type][$s_type][$id])?true:false) : (isset($this->data[$type][$id])?true:false));
    }
    
    // item    
    function item_store($type,$id,$data, $s_type=false) {
        
        if ($s_type) { 
            if (isset($this->data[$type][$s_type][$id])) return false;
            $this->data[$type][$s_type][$id]=$data;
        }
        else
            if (isset($this->data[$type][$id])) return false;
            $this->data[$type][$id]=$data;
        
        // core_c::cprint('[cache] item store '.$type.' : '.$s_type.' : '.$id);
        return true;
    }
    
    // item
    function item_retrive($type,$id,$s_type=false) {
      //  core_c::cprint('[cache] item retrive '.$type.' : '.$s_type.' : '.$id);
      
        if ($s_type!==false) {
         return (isset($this->data[$type][$s_type][$id] ) ? $this->data[$type][$s_type][$id]  : false);
        }
        else {
         return (isset($this->data[$type][$id]) ? $this->data[$type][$id] : false);
        }
    }
    
    /****
    * @desc enable/disable
    */
    
    function enable($fl=true) {
        $this->enabled=$fl;
    }
    
    /*
    
    */    
    
    function cache_c ($root_path, $enabled) {     
        $this->config['lifetime']=3600; //sec         // -1 == unlimited ttl         
        $this->config['path']=$root_path . 'cache/';    
        $this->enable($enabled);    
    }
    
    /*
        id from array
    */
    
    function make_id($ident) {
        $this->ident = $ident;
        return sprintf("%u", crc32(ss_pack_array($ident)));        
    }
    
    /*
        serialize
    */
    
    function pack($data) {
        
        return ss_serialize($data);
        
    }
    
    /*
        unserialize
    */
    
    function unpack($data) {
        
        $ret=ss_unserialize($data);
        return $ret;
        
    }
    
    /*
    
    [uid] => 0
    [gid] => 0

    [size] => 1114
    [atime] => 1061067181
    [mtime] => 1056136526
    [ctime] => 1056136526
 
    
    cal make_id before
    
    return 
        1 if expire
        true if exists & ok
        false if not exists
    
    */
    
    function check($id) {
        
        $core = &core_c::get_instance();
     //   $core->dprint('[cache] check : '.$id);

        $fcheck = $this->config['path'].$id;
        $fp = @fopen($fcheck, "r");
        if (!$fp) return false;
        
        $fstat = fstat($fp);
        fclose($fp); 
        
        if ($this->config['lifetime']==-1) return true; // unlimited ttl
        
        if (time()>($fstat['mtime']+$this->config['lifetime'])) {
            return false;
        }
        
        return true;
    }
    
    /*
    
    cal make_id before
    
    */
    
    function update($id, $data, $ttl=false) {
        
        $this->id = $id;
        $this->needupdate = true;
        $this->page_data = array(
            'config'=>array(
                'ttl'=>$ttl
            ),
            'data' => $data
        );              
        return true;
        
    }
    
    /*
         
    */
    
    function cancel() {
        $this->upd_hook=true;
    }
    
    /*
          
    */
    
    function save() {
        
        /*
        var_dump($ident,'@');   
        core_c::cprint('[color=blue]save==[/color]');
        var_dump($this->upd_hook,$this->id);
        */
        
        if (!$this->needupdate || $this->upd_hook) return false;
        
        $fcheck = $this->config['path'].$this->id;
        $fp = @fopen($fcheck, "w");        
        if (!$fp) return false;
        $buff = $this->page_data;
        $buff['cache'] = $this->data;       
        fwrite($fp, $this->pack($buff));       
        fclose($fp);               
        return true;
        
    }
    
    
    function get($id) {
        
        $core = &core_c::get_instance();
    //    $core->dprint('[cache] get : '.$id);       
        
        $fcheck = $this->config['path'].$id;
        $fp = @fopen($fcheck, "r");        
        if (!$fp) return false;
        $data = fread ($fp, filesize($fcheck));       
        fclose($fp);   
        $this->buffer = $this->unpack($data);  
        $this->data = $this->buffer['cache'];                          
        return ($this->buffer['data']);
    }
   
   
   function clear() {
       
    $i=0;
    $dir = @opendir($this->config['path']);
	while( false !== ($file = @readdir($dir)) )
	{
    	$path = $this->config['path'] . '/' . $file;
		if( !is_dir($path) && $file!='..' && $file!='.' && !preg_match('/^\.htaccess$/',$file))
		{            
			@unlink($path);
		}
	}
    $i++;
       
   }
   
   // cleared $i files
    
}  
  
?>