<?php

/*
	File: $Id: core_init.php,v 1.1.2.33 2007/02/24 23:33:17 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005
	Author: surgeon <sursoft@nm.ru> http://skillz.ru

    NOTE: GLOBAL SCOPE, on before core load
*/


if ( !defined('MAIN_LOADED') ) {
	die("Direct access not allowed");
}

error_reporting  (E_ERROR & ~E_NOTICE); // This will NOT report uninitialized variables
@ini_set('display_errors',( (defined('DEBUG') && DEBUG!=0)?'on':'off'));  
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

/*
     PHP5 with register_long_arrays off?
     Old school support?
*/

if (isset($_POST))
{
	$HTTP_POST_VARS = &$_POST;
	$HTTP_GET_VARS = &$_GET;
	$HTTP_SERVER_VARS = &$_SERVER;
	$HTTP_COOKIE_VARS = &$_COOKIE;
	$HTTP_ENV_VARS = &$_ENV;
	$HTTP_POST_FILES = &$_FILES;

	// _SESSION is the only superglobal which is conditionally set
	if (isset($_SESSION))
	{
		$HTTP_SESSION_VARS = &$_SESSION;
	}  
}

// unset globals if 'register_globals' is on
// The following code (unsetting globals) was contributed by Matt Kavanagh

if (@ini_get('register_globals') == '1' || strtolower(@ini_get('register_globals')) == 'on')
{
	// Not only will array_merge give a warning if a parameter
	// is not an array, it will actually fail. So we check if
	// HTTP_SESSION_VARS has been initialised.
	if (!isset($HTTP_SESSION_VARS))
	{
		$_SESSION = array();
	}

	$input = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_SESSION, $_ENV, $_FILES);

	unset($input['input']);

	while (list($var,) = @each($input))
	{
		unset($$var);
	}

	unset($input);
}

//
// addslashes to vars if magic_quotes_gpc is off
// this is a security precaution to prevent someone
// trying to break out of a SQL statement.
//
if( !get_magic_quotes_gpc() )
{

    if( is_array($_REQUEST) )
	{
		while( list($k, $v) = each($_REQUEST) )
		{
			if( is_array($_REQUEST[$k]) )
			{
				while( list($k2, $v2) = each($_REQUEST[$k]) )
				{
					$_REQUEST[$k][$k2] = addslashes($v2);
				}
				@reset($_REQUEST[$k]);
			}
			else
			{
				$_REQUEST[$k] = addslashes($v);
			}
		}
		@reset($_REQUEST);
	}                  
    
	if( is_array($_GET) )
	{
		while( list($k, $v) = each($_GET) )
		{
			if( is_array($_GET[$k]) )
			{
				while( list($k2, $v2) = each($_GET[$k]) )
				{
					$_GET[$k][$k2] = addslashes($v2);
				}
				@reset($_GET[$k]);
			}
			else
			{
				$_GET[$k] = addslashes($v);
			}
		}
		@reset($_GET);
	}

	if( is_array($_POST) )
	{
		while( list($k, $v) = each($_POST) )
		{
			if( is_array($_POST[$k]) )
			{
				while( list($k2, $v2) = each($_POST[$k]) )
				{
					$_POST[$k][$k2] = addslashes($v2);
				}
				@reset($_POST[$k]);
			}
			else
			{
				$_POST[$k] = addslashes($v);
			}
		}
		@reset($_POST);
	}

	if( is_array($_COOKIE) )
	{
		while( list($k, $v) = each($_COOKIE) )
		{
			if( is_array($_COOKIE[$k]) )
			{
				while( list($k2, $v2) = each($_COOKIE[$k]) )
				{
					$_COOKIE[$k][$k2] = addslashes($v2);
				}
				@reset($_COOKIE[$k]);
			}
			else
			{
				$_COOKIE[$k] = addslashes($v);
			}
		}
		@reset($_COOKIE);
	}
}

//
// Define some basic configuration arrays this also prevents
// malicious rewriting of language and otherarray values via
// URI params
//
$SID = '';
$config = array(); //for backward comp, point to $core->config
$board_config = &$config; // REMOVE THIS, later!
$userdata = array();
$theme = array();
$images = array();
$lang = array();
$nav_links = array();

$gen_simple_header = FALSE;

//SUR: SHOP VARS
$g_cart = array();      /*  */

@include($root_path . 'includes/core_c/config.'.$phpEx);

include($root_path . 'includes/functions.'.$phpEx);

if( !defined("ALREADY_INSTALLED") )
{
	$inst_url = $root_path . 'install/install.'.$phpEx;
	if (!file_exists(ss_realpath($inst_url))) {
    	// fix multiple redir if install script missing
    	die('[ERROR] Cant open config file. Unable to locate install script');
    }
	header("Location: $inst_url");
	exit;
}

// includes

include($root_path . 'includes/constants.'.$phpEx);
include($root_path . 'includes/template.'.$phpEx);

include($root_path . 'includes/sessions.'.$phpEx);

//

include($root_path . 'includes/core.'.$phpEx);

include($root_path . 'includes/function_core.'.$phpEx);
include($root_path . 'includes/ss_posting.'.$phpEx);

include($root_path . 'includes/db.'.$phpEx);

//
// Obtain and encode users IP
//

$client_ip = ( !empty($HTTP_SERVER_VARS['REMOTE_ADDR']) ) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ( ( !empty($HTTP_ENV_VARS['REMOTE_ADDR']) ) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : $REMOTE_ADDR );
$user_ip = encode_ip($client_ip);

//
// Setup cms wide options, if this fails
//

if ( !core_parse_config() )
	message_die(CRITICAL_ERROR, "Could not query config information", "", __LINE__, __FILE__, $sql);

//
// additional init
//

$config['client_ip'] = $client_ip;
$config['user_ip'] = $user_ip;

$config [ 'site_path' ] = $_SERVER['DOCUMENT_ROOT'];

$config['script_path'] = trim($config['script_path']);
if (empty($config['script_path'])) {
	$config['script_path'] = '/';
}

// --> DETECT SCRIPT PATH
/*
	$s_path = strrpos($_SERVER['SCRIPT_NAME'], '/');
	if ( $s_path > 1) {
		$config['script_path'] = substr($_SERVER['SCRIPT_NAME'],0,$s_path+1);
    } else
	$config['script_path'] = '/';
*/
// <--


if (strrpos($config [ 'site_path' ],'/')==strlen($config [ 'site_path' ])-1)
	$config [ 'site_path' ] = substr($config [ 'site_path' ],0,strlen($config [ 'site_path' ])-1);

$config [ 'site_path' ] .= $config['script_path'];   //  

$config [ 'page_gen_mode' ] = PAGE_GEN_NORMAL;

$config [ 'server_name' ] = $_SERVER['SERVER_NAME'];	//[FIX]: redirect issue
$config [ 'server_port' ] = $_SERVER['SERVER_PORT'];	//[FIX]: redirect issue

$config [ 'self_url' ] = 'http://' . $config['server_name'] . $config['script_path'];        //  http://site.ru/site_path/

// printer friendly output
$config['printer_friendly'] = FALSE;
if (isset($_GET['2print']) || isset($_POST['2print']))
	$config['printer_friendly'] = 'yes';

// debug site root
// $config['script_path'] = '/sshop-dev/';
//

define('IS_ROBOT', is_robot() );

// [SEC] fix - need to clear this var for some reason!
// unset($dbpasswd);

$g_act = (empty($HTTP_GET_VARS[POST_ACT_URL])) ? '' : substr($HTTP_GET_VARS[POST_ACT_URL],0,30);
$g_act = (empty($HTTP_POST_VARS[POST_ACT_URL])) ? $g_act : substr($HTTP_POST_VARS[POST_ACT_URL],0,30);

// CORE INSTANCE

$core = new core_c;

//$core->dprint_r($config['script_path']);
//$core->dprint_r($config['site_path']);

//
// gzip_compression
//

$core->do_gzip_compress = FALSE;

if (!defined('CORE_SKIP_HEADERS')) {

	if ( !defined('IN_ADMIN') && $core->config['gzip_compress']) {

	   $g_encoding = '';

	   if (function_exists("gzcompress") && ! (headers_sent() || connection_aborted()) && isset($core->SERVER['HTTP_ACCEPT_ENCODING']))
	   {
	        if (strpos($core->SERVER['HTTP_ACCEPT_ENCODING'],'x-gzip') !== false) $g_encoding = "x-gzip";
	        if (strpos($core->SERVER['HTTP_ACCEPT_ENCODING'],'gzip') !== false) $g_encoding = "gzip";
	   }

	   if ( !empty($g_encoding) && extension_loaded('zlib') )  {
	      $core->do_gzip_compress = TRUE;
	      ob_start();
	      ob_implicit_flush(0);
	      header("Content-Encoding: $g_encoding");
	   }
	}

	// HEADERS

	// Work around for "current" Apache 2 + PHP module which seems to not
	// cope with private cache control setting
	if (!empty($core->SERVER['SERVER_SOFTWARE']) && strstr($core->SERVER['SERVER_SOFTWARE'], 'Apache/2'))
	{
	    header ('Cache-Control: no-cache, pre-check=0, post-check=0');
	}
	else
	{
	    header ('Cache-Control: private, pre-check=0, post-check=0, max-age=0');
	}
	header ('Expires: 0');
	header ('Pragma: no-cache');

	//
	// Show 'Board is disabled' message if needed.
	//

	if( $config['board_disable'] && !defined("IN_ADMIN") && !defined("IN_LOGIN") )
	{
	    $message = (!empty($core->config['board_disable_message'])) ? $core->config['board_disable_message'] : 'Site closed for the technical works. Please visit us later.';
	    message_die(CRITICAL_MESSAGE, $message, 'Warning!');
	}
}


// EOF

?>