<?php
/*
 	File: $Id: render_header.php,v 1.1.2.22 2007/02/24 22:47:30 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005
	Author: surgeon <sursoft@nm.ru> http://skillz.ru
*/

if ( !defined('MAIN_LOADED') )
{
	die("Direct access not allowed");
}

// do not render twice

if (defined('HEADER_INC'))
	return;

define('HEADER_INC', TRUE);

//
// Parse and show the overall header.
//

// SEO
if ( !$this->userdata['session_logged_in'] )
{
	ob_start();
}


//
// Generate logged in/logged out status
//
if ( $this->userdata['session_logged_in'] )
{
	$u_login_logout = 'login.'.$this->phpEx.'?logout=true&amp;sid=' . $this->userdata['session_id'];
	$l_login_logout = $this->lang['Logout'] . ' [ ' . htmlspecialchars($this->userdata['username']) . ' ]';
}
else
{

	$u_login_logout = 'login.'.$this->phpEx;
	$l_login_logout = $this->lang['Login'];

	// add meta keys only when logged out
	$this->template->assign_vars(array(
    	'SITE_META_DESCRIPTION' => $this->page['meta_desc'],
    	'SITE_META_KEYWORDS' => $this->page['meta_keywords']
    ));

}

$s_last_visit = ( $this->userdata['session_logged_in'] ) ? create_date($this->config['default_dateformat'], $this->userdata['user_lastvisit'], $this->config['board_timezone']) : '';

// Format Timezone.
$l_timezone = explode('.', $this->config['board_timezone']);
$l_timezone = (count($l_timezone) > 1 && $l_timezone[count($l_timezone)-1] != 0) ? $this->lang[sprintf('%.1f', $this->config['board_timezone'])] : $this->lang[number_format($this->config['board_timezone'])];

// printer friend

$theme_css_file = 'theme.css';

if ($this->config['printer_friendly']=='yes') {
	$theme_css_file = '../print_version.css';
    $this->template->assign_block_vars('SWITCH_2PRINT_ON', array());
}

$self_full_url = /*'/' . $this->config['script_path'] .*/  $_SERVER['REQUEST_URI']; /*substr($this->config ['self_url'],0,strlen($this->config ['self_url'])-1) .*/

//
// FIX URL FOR PRINT VIEW
//

if (isset($_SERVER['REDIRECT_QUERY_STRING'])) {
	$print_url_postfix = (isset($_SERVER['REDIRECT_QUERY_STRING']) && !empty($_SERVER['REDIRECT_QUERY_STRING'])) ? ('?' . $_SERVER['REDIRECT_QUERY_STRING'].'&') : '?';
	$print_url = append_sid(basename($_SERVER['SCRIPT_NAME']) . $print_url_postfix . '2print=true',$this->g_cat);
}
else
{
	// direct page
    if (isset($this->config['core_page_direct']) && $this->config['core_page_direct']) {
		$print_url = append_sid('index.php?'.POST_PAGE_URL.'='.$this->page['name'].'&2print=true');
    }
    else		// cats trick
    if ($this->g_cat && substr($_SERVER['REQUEST_URI'],$_SERVER['REQUEST_URI']-1,1)=='/') {
		$print_url = append_sid('index.php?'.POST_GCAT_URL.'='.$this->g_cat.'&2print=true');
    }
    else {
		$print_url = $self_full_url . ((strpos($self_full_url,'?')!==FALSE) ? ( '&2print=true') : ('?2print=true'));
    }
}

// $this->dprint_r($_SERVER);
// ADD PAGE COMMENT TO TITLE

$page_title = $this->page['title'] . ( empty($this->page['comment']) ? '' : (' - ' . $this->page['comment'] ));

// FIX FOR [C|R] PAGE LAYOUT

if ($this->config['page_gen_mode']==PAGE_GEN_NO_LEFT)
	$this->template->assign_block_vars('SWITCH_NO_LEFT_ON', array());
else
	$this->template->assign_block_vars('SWITCH_NO_LEFT_OFF', array());

// FIX PATH

// var_dump(append_sid($this->config ['self_url']),$self_full_url,$this->config['template_path']);

$this->config['template_path'] = $this->config['script_path'] . $this->config['template_path'];

$this->template->assign_vars(array(

    'LANG' => 'lang_english',       //<--SUR, fix it

	'TEMPLATE_PATH' => $this->config['template_path'],	// TEMPLATE PATH
    'THEME_CSS_FILE' => $theme_css_file,

    'ADMIN_LINK' => ( $this->userdata['user_level'] == ADMIN ) ? '<a href="' . $this->admin_url . '">' . $this->lang['Admin_panel'] . '</a>' : '',

	'SITENAME' => $this->config['sitename'],
	'SITE_DESCRIPTION' => $this->config['site_desc'],

	'SELF_URL' => append_sid($this->config ['self_url']),
    'SELF_FULL_URL' => $self_full_url,
    'PRINT_URL' => $print_url,

    'SITE_BRIEF_DESCRIPTION' => $this->config['site_briefdesc'],
    'SITE_ANNO' => $this->config['site_anno'],

    'SITE_META_EXTRA' => $this->page['meta_extra'],

	'PAGE_TITLE' => $page_title,

	'LAST_VISIT_DATE' => sprintf($this->lang['You_last_visit'], $s_last_visit),

	'CURRENT_TIME' => sprintf($this->lang['Current_time'], create_date($this->config['default_dateformat'], time(), $this->config['board_timezone'])),

    'SS_USERNAME' => ( ( $this->userdata['session_logged_in'] ) ? $this->userdata['username'] : ''),
    'SS_WELCOME'  => $this->lang['ss_welcome'],

	'L_USERNAME' => $this->lang['Username'],
	'L_PASSWORD' => $this->lang['Password'],

	'L_LOGIN_LOGOUT' => $l_login_logout,
	'U_LOGIN_LOGOUT' => append_sid($u_login_logout),

	'L_LOGIN' => $this->lang['Login'],
	'L_LOG_ME_IN' => $this->lang['Log_me_in'],
	'L_AUTO_LOGIN' => $this->lang['Log_me_in'],
	'L_INDEX' => sprintf($this->lang['Forum_Index'], $this->config['sitename']),
	'L_REGISTER' => $this->lang['Register'],
	'L_PROFILE' => $this->lang['Profile'],
	'L_SEARCH' => $this->lang['Search'],
	'L_PRIVATEMSGS' => $this->lang['Private_Messages'],
	'L_WHO_IS_ONLINE' => $this->lang['Who_is_Online'],
	'L_MEMBERLIST' => $this->lang['Memberlist'],

    'U_INDEX' => append_sid('index.'.$this->phpEx),
	'U_REGISTER' => append_sid('profile.'.$this->phpEx.'?mode=register'),
	'U_PROFILE' => append_sid('profile.'.$this->phpEx.'?mode=editprofile'),
	'U_SEARCH' => append_sid('search.'.$this->phpEx),
	'U_MEMBERLIST' => append_sid('memberlist.'.$this->phpEx),
	'U_MODCP' => append_sid('ss_mod.'.$this->phpEx),


	'S_CONTENT_DIRECTION' => $this->lang['DIRECTION'],
	'S_CONTENT_ENCODING' => $this->lang['ENCODING'],
	'S_CONTENT_DIR_LEFT' => $this->lang['LEFT'],
	'S_CONTENT_DIR_RIGHT' => $this->lang['RIGHT'],
	'S_TIMEZONE' => sprintf($this->lang['All_times'], $l_timezone),
	'S_LOGIN_ACTION' => append_sid('login.'.$this->phpEx),

    // from page conf //defaults in theme.cfg
	'BODY_LEFT_WIDTH'  =>  $this->page['width_body_left'],
	'BODY_MAIN_WIDTH'  =>  $this->page['width_body_main'],
	'BODY_RIGHT_WIDTH' => $this->page['width_body_right'],

    // theme
    'BLOCKS_MARGIN' =>   (isset($this->config['theme_blocks_margin']) ? $this->config['theme_blocks_margin'] : 0),
    'BLOCKS_H_MARGIN' => (isset($this->config['theme_h_blocks_margin']) ? $this->config['theme_h_blocks_margin'] : 0),
    'TPL_PAGE_GEN_MODE' => $this->config['page_gen_mode'],

    // catalog
    'RUB2DOL' => '1 .. = ' . $this->config['shop_rubsfordol'] . ' .'

	)
);

// generate cats menu (if horizontal --> {MENU_CATEGORIES})
if ($this->get_cfg_var('tpl_generate_cats')!==FALSE) {
	if ($this->get_cfg_var('tpl_generate_cats')==1)  $this->make_cats_menu_box();
}

        $this->template->set_filenames(array(
	        'overall_header' => ( ( $this->config [ 'page_gen_mode' ] == PAGE_GEN_ONLY_BODY ) ? 'overall_ob_header.tpl' : 'overall_header.tpl'),
	        'body_header' => (  ( $this->config [ 'page_gen_mode' ] != PAGE_GEN_WIDE_BODY ) ?  'body_header.tpl' : 'body_header_wide.tpl' )
	            )
	    );

        $this->nav_render();

	    $this->template->pparse('overall_header');

	    if (  ($this->config [ 'page_gen_mode' ] != PAGE_GEN_ONLY_BODY)
	      &&  ($this->config [ 'page_gen_mode' ] != PAGE_GEN_WIDE_BODY)  )
	    {
	        $this->template->assign_block_vars('not_only_body', array() );

            if (!defined('IN_MOD'))
            $this->template->pparse('body_header');
	    }

?>
