<?php

/*
 	File: $Id: functions.php,v 1.1.4.25 2007/02/24 22:47:29 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005,
	Author: surgeon <sursoft@nm.ru> http://skillz.ru

    part of code based on phpBB, (C) 2001 The phpBB Group
*/

if ( !defined('MAIN_LOADED') )
{
	die('Direct access not allowed');
	exit;
}


function get_db_stat($mode)
{
	return false;
}

// added at ss 2.0.11 to properly format the username
function ss_clean_username($username)
{
	$username = htmlspecialchars(rtrim(trim($username), "\\"));
	$username = substr(str_replace("\\'", "'", $username), 0, 25);
	$username = str_replace("'", "\\'", $username);

	return $username;
}

//
// Get Userdata, $user can be username or user_id. If force_str is true, the username will be forced.
//
function get_userdata($user, $force_str = false)
{
	global $db;

	if (intval($user) == 0 || $force_str)
	{
		$user = ss_clean_username($user);
	}
	else
	{
		$user = intval($user);
	}

	$sql = "SELECT *
		FROM " . USERS_TABLE . "
		WHERE ";
	$sql .= ( ( is_integer($user) ) ? "user_id = $user" : "username = '" .  $user . "'" ) . " AND user_id <> " . ANONYMOUS;
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Tried obtaining data for a non-existent user', '', __LINE__, __FILE__, $sql);
	}

	return ( $row = $db->sql_fetchrow($result) ) ? $row : false;
}

//
// Initialise user settings on page load
function init_userprefs($userdata)
{
	global $core;
	global $config, $theme, $images, $db, $table_prefix;
	global $template, $lang, $phpEx, $root_path;
	global $nav_links;

	if ( $userdata['user_id'] != ANONYMOUS )
	{
		if ( !empty($userdata['user_lang']))
		{
			$config['default_lang'] = $userdata['user_lang'];
		}

        /*
		if ( !empty($userdata['user_dateformat']) )
		{
			$config['default_dateformat'] = $userdata['user_dateformat'];
		}

		if ( isset($userdata['user_timezone']) )
		{
			$config['board_timezone'] = 4; //SUR::: $userdata['user_timezone'];
		}
        */
	}

	if ( !file_exists(@ss_realpath($root_path . 'language/lang_' . $config['default_lang'] . '/lang_main.'.$phpEx)) )
	{
		$config['default_lang'] = 'english';
	}

    //SSHOP

	include($root_path . 'language/lang_' . $config['default_lang'] . '/lang_main.' . $phpEx);
  	include($root_path . 'language/lang_' . $config['default_lang'] . '/lang_shop.' . $phpEx);

	if ( defined('IN_ADMIN') )
	{
		if( !file_exists(@ss_realpath($root_path . 'language/lang_' . $config['default_lang'] . '/lang_admin.'.$phpEx)) )
		{
			$config['default_lang'] = 'english';
		}

		include($root_path . 'language/lang_' . $config['default_lang'] . '/lang_admin.' . $phpEx);
	}

	if ( !$config['override_user_style'] && $userdata['user_id'] != ANONYMOUS && ( empty($userdata['user_style']) || $userdata['user_style'] != DEFAULT_TEMPLATE ))
		{
			if ( $theme = setup_style($userdata['user_style']) )
			{
				return;
			}
		}

    if (IS_ROBOT)
	{
		$sql = "SELECT bot_style FROM " . $table_prefix . "bots WHERE bot_name='" . IS_ROBOT . "'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$theme = setup_style($row['bot_style']);
	} else {

		$theme = setup_style($config['default_style']);
	}

	return;
}

function setup_style($style)
{
	global $db, $userdata, $theme, $config, $template, $root_path, $core;


    //
	// Set up style
	//
 	$template_path = 'templates/' ;
    $template_name = '';

    //hack for stylez! fix some day
    if (isset($core->page['page_tmpl']) && $core->page['page_tmpl']!=DEFAULT_TEMPLATE) {
	    $template_name = $core->page['page_tmpl'];
    }
    else
	if (empty($style) || $style==DEFAULT_TEMPLATE || $config['override_user_style']) {
    	$template_name = $config['default_style'];
    }
    else
    if (empty($core->page['page_tmpl']) || $core->page['page_tmpl']==DEFAULT_TEMPLATE)
    	$template_name = $config['default_style'];
    else
    	$template_name = $core->page['page_tmpl'];

    //ACP & MCP use separate template

    if (isset($config['default_acp_style']) && ( defined('IN_ADMIN') || defined('IN_MOD')))
	    $template_name = $config['default_acp_style'];

    if (empty($template_name)) {
    	$core->errprint('Fail to load template',0);
        return FALSE;
    }

	$config['template_path'] = $template_path . $template_name;

	$template = new Template($root_path . $template_path . $template_name);

	if ( $template )
	{
		$current_template_path = $template_path . $template_name;
		@include($root_path . $template_path . $template_name . '/' . 'theme.cfg');

		if ( !defined('TEMPLATE_CONFIG') )
		{
			message_die(CRITICAL_ERROR, "Could not open $template_name template config file : " . $template_name, '', __LINE__, __FILE__);
		}

		$img_lang = ( file_exists(@ss_realpath($root_path . $current_template_path . '/images/lang_' . $config['default_lang'])) ) ? $config['default_lang'] : 'english';

	}
	return $template_name;
}

function encode_ip($dotquad_ip)
{
	$ip_sep = explode('.', $dotquad_ip);
	return sprintf('%02x%02x%02x%02x', $ip_sep[0], $ip_sep[1], $ip_sep[2], $ip_sep[3]);
}

function decode_ip($int_ip)
{
	$hexipbang = explode('.', chunk_split($int_ip, 2, '.'));
	return hexdec($hexipbang[0]). '.' . hexdec($hexipbang[1]) . '.' . hexdec($hexipbang[2]) . '.' . hexdec($hexipbang[3]);
}

//
// Create date/time from format and timezone
//
function create_date($format, $gmepoch, $tz)
{
	global $config, $lang;
	static $translate;

	if ( empty($translate) ) //SUR:disabled && $config['default_lang'] != 'english' )
	{
		@reset($lang['datetime']);
		while ( list($match, $replace) = @each($lang['datetime']) )
		{
			$translate[$match] = $replace;
		}
	}

	return ( !empty($translate) ) ? strtr(@gmdate($format, $gmepoch + (3600 * $tz)), $translate) : @gmdate($format, $gmepoch + (3600 * $tz));
}

//
// Pagination routine, generates
// page number sequence
//
function generate_pagination($base_url, $num_items, $per_page, $start_item, $add_prevnext_text = TRUE)
{
        global $lang, $core;

        //
        // BEGIN Pagination Mod
        //
        $begin_end = 3;
        $from_middle = 1;

        $total_pages = ceil($num_items/$per_page);

        if ( $total_pages == 1 )
        {
                return '';
        }

        $on_page = floor($start_item / $per_page) + 1;

        // fix for first -&-
        if (strpos($base_url,'?')===FALSE) {
        	$l_start_url = "?".POST_START_URL."=";
        }
        else {
        	$l_start_url = "&".POST_START_URL."=" ;
        }

        $page_string = '';
        if ( $total_pages > ((2*($begin_end + $from_middle)) + 2) )
        {
                $init_page_max = ( $total_pages > $begin_end ) ? $begin_end : $total_pages;

                for($i = 1; $i < $init_page_max + 1; $i++)
                {
                        $page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . $l_start_url . ( ( $i - 1 ) * $per_page ) , $core->g_cat) . '">' . $i . '</a>';
                        if ( $i <  $init_page_max )
                        {
                                $page_string .= ", ";
                        }
                }

                if ( $total_pages > $begin_end )
                {
                        if ( $on_page > 1  && $on_page < $total_pages )
                        {
                                $page_string .= ( $on_page > ($begin_end + $from_middle + 1) ) ? ' ... ' : ', ';

                                $init_page_min = ( $on_page > ($begin_end + $from_middle) ) ? $on_page : ($begin_end + $from_middle + 1);
                                $init_page_max = ( $on_page < $total_pages - ($begin_end + $from_middle) ) ? $on_page : $total_pages - ($begin_end + $from_middle);

                                for($i = $init_page_min - $from_middle; $i < $init_page_max + ($from_middle + 1); $i++)
                                {
                                		$url_tail = ($i!=1) ? $l_start_url . ( ( $i - 1 ) * $per_page ) : '';
                                        $page_string .= ($i == $on_page) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . $url_tail, $core->g_cat ) . '">' . $i . '</a>';
                                        if ( $i <  $init_page_max + $from_middle )
                                        {
                                                $page_string .= ', ';
                                        }
                                }

                                $page_string .= ( $on_page < $total_pages - ($begin_end + $from_middle) ) ? ' ... ' : ', ';

                        }
                        else
                        {
                                $page_string .= ' ... ';
                        }

                        for($i = $total_pages - ($begin_end - 1); $i < $total_pages + 1; $i++)
                        {
                        		$url_tail = ($i!=1) ? $l_start_url . ( ( $i - 1 ) * $per_page ) : '';
                                $page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>'  : '<a href="' . append_sid($base_url . $url_tail, $core->g_cat ) . '">' . $i . '</a>';
                                if( $i <  $total_pages )
                                {
                                        $page_string .= ", ";
                                }
                        }
                }
        }
        else
        {
                for($i = 1; $i < $total_pages + 1; $i++)
                {
                		$url_tail = ($i!=1) ? $l_start_url . ( ( $i - 1 ) * $per_page ) : '';
                        $page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . $url_tail, $core->g_cat ) . '">' . $i . '</a>';
                        if ( $i <  $total_pages )
                        {
                                $page_string .= ', ';
                        }
                }
        }

        if ( $add_prevnext_text )
        {
                if ( $on_page > 1 )
                {
                		$url_tail = ($on_page!=2) ? $l_start_url . ( ( $on_page - 2 ) * $per_page ) : '';
                        $page_string = ' <a href="' . append_sid($base_url . $url_tail, $core->g_cat ) . '">' . $lang['Previous'] . '</a>&nbsp;&nbsp;' . $page_string;
                }

                if ( $on_page < $total_pages )
                {
                        $page_string .= '&nbsp;&nbsp;<a href="' . append_sid($base_url . $l_start_url . ( $on_page * $per_page ), $core->g_cat ) . '">' . $lang['Next'] . '</a>';
                }

        }

        $page_string = $lang['Goto_page'] . ' ' . $page_string;

        return $page_string;
}


//
// This does exactly what preg_quote() does in PHP 4-ish
// If you just need the 1-parameter preg_quote call, then don't bother using this.
//
function ss_preg_quote($str, $delimiter)
{
	$text = preg_quote($str);
	$text = str_replace($delimiter, '\\' . $delimiter, $text);

	return $text;
}

function make_jumpbox() {
}

//
// This is general replacement for die(), allows templated
// output in users (or default) language, etc.
//
// $msg_code can be one of these constants:
//
// GENERAL_MESSAGE : Use for any simple text message, eg. results
// of an operation, authorisation failures, etc.
//
// GENERAL ERROR : Use for any error which occurs _AFTER_ the
// common.php include and session code, ie. most errors in
// pages/functions
//
// CRITICAL_MESSAGE : Used when basic config data is available but
// a session may not exist, eg. banned users
//
// CRITICAL_ERROR : Used when config data cannot be obtained, eg
// no database connection. Should _not_ be used in 99.5% of cases
//

/*
		[SUR]: $mode = default mode for function

						1			2				3				4				5			6					7
*/

function message_die($msg_code, $msg_text = '', $msg_title = '', $err_line = '', $err_file = '', $sql = '', $pagemode = -127)
{
	global $core;
	//die("CODE: $msg_code <br> MSG: $msg_text <br> TITLE: $msg_title <br> ERR_LINE: $err_line <br> ERR_FILE: $err_file <br> SQL: $sql");
    //print $msg_text;
	global $db, $template, $config, $theme, $lang, $phpEx, $root_path, $nav_links, $gen_simple_header, $images;
	global $userdata, $user_ip, $session_length;
	global $starttime;


    if (!empty($pagemode) && $pagemode != -127)
	    $config [ 'page_gen_mode' ] = $pagemode;

//+MOD: Fix message_die for multiple errors MOD
	static $msg_history;
	if( !isset($msg_history) )
	{
		$msg_history = array();
	}
	$msg_history[] = array(
		'msg_code'	=> $msg_code,
		'msg_text'	=> $msg_text,
		'msg_title'	=> $msg_title,
		'err_line'	=> $err_line,
		'err_file'	=> $err_file,
		'sql'		=> $sql
	);
//-MOD: Fix message_die for multiple errors MOD


if(defined('HAS_DIED'))
	{
//+MOD: Fix message_die for multiple errors MOD

		//
		// This message is printed at the end of the report.
		// Of course, you can change it to suit your own needs. ;-)
		//
		$custom_error_message = 'Please, contact the %swebmaster%s.';
		if ( !empty($core->config) && !empty($core->config['board_email']) )
		{
			$custom_error_message = sprintf($custom_error_message, '<a href="mailto:' . $core->config['board_email'] . '">', '</a>');
		}
		else
		{
			$custom_error_message = sprintf($custom_error_message, '', '');
		}
		echo "<html>\n<body style='font-family:verdana;color:darkred;font-size:10px'>\n<b>Critical Error!</b><br />\nmessage_die() was called multiple times.<br />&nbsp;<hr />";
		for( $i = 0; $i < count($msg_history); $i++ )
		{
			echo '<b>Error #' . ($i+1) . "</b>\n<br />\n";
			if( !empty($msg_history[$i]['msg_title']) )
			{
				echo '<b>' . $msg_history[$i]['msg_title'] . "</b>\n<br />\n";
			}
			echo $msg_history[$i]['msg_text'] . "\n<br /><br />\n";
			if( !empty($msg_history[$i]['err_line']) )
			{
				echo '<b>Line :</b> ' . $msg_history[$i]['err_line'] . '<br /><b>File :</b> ' . $msg_history[$i]['err_file'] . "</b>\n<br />\n";
			}
			if( !empty($msg_history[$i]['sql']) )
			{
				echo '<b>SQL :</b> ' . $msg_history[$i]['sql'] . "\n<br />\n";
			}
			echo "&nbsp;<hr />\n";
		}
		echo $custom_error_message . '<hr /><br clear="all">';
		die("</body>\n</html>");
//-MOD: Fix message_die for multiple errors MOD
	}


	if(defined('HAS_DIED'))
	{
		die("ERROR:  ");
	}

   	define('HAS_DIED', 1);;

	$sql_store = $sql;

	//
	// Get SQL error if we are debugging. Do this as soon as possible to prevent
	// subsequent queries from overwriting the status of sql_error()
	//

	if ( defined('DEBUG') && ( $msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR ) )
	{

		$sql_error = $db->sql_error();

		$debug_text = '';

		if ( $sql_error['message'] != '' )
		{
			$debug_text .= '<br /><br />SQL Error : ' . $sql_error['code'] . ' ' . $sql_error['message'];
		}

		if ( $sql_store != '' )
		{
			$debug_text .= "<br /><br />$sql_store";
		}

		if ( $err_line != '' && $err_file != '' )
		{
			$debug_text .= '</br /><br />Line : ' . $err_line . '<br />File : ' . $err_file;
		}
	}

	if( empty($core->page) && $msg_code != CRITICAL_ERROR )
	{
		// $userdata = session_pagestart($user_ip, PAGE_INDEX);
		// init_userprefs($userdata);
        $core->page_register();
	}

    if ( $msg_code == CRITICAL_MESSAGE ) {

            $config [ 'page_gen_mode' ] = PAGE_GEN_WIDE_BODY;
    }

	//
	// If the header hasn't been output then do it
	//
	if ( !defined('HEADER_INC') && $msg_code != CRITICAL_ERROR )
	{
		//
		// Load the Page Header
		//
		if ( defined('IN_ADMIN') )
		{
			include($root_path . 'admin/page_header_admin.'.$phpEx);
		}
	}

    //

	switch($msg_code)
	{
		case GENERAL_MESSAGE:
			if ( $msg_title == '' )
			{
				$msg_title = $lang['Information'];
			}
			break;

		case CRITICAL_MESSAGE:
			if ( $msg_title == '' )
			{
				$msg_title = $lang['Critical_Information'];
			}
			break;

		case GENERAL_ERROR:
			if ( $msg_text == '' )
			{
				$msg_text = $lang['An_error_occured'];
			}

			if ( $msg_title == '' )
			{
				$msg_title = $lang['General_Error'];
			}
			break;

		case CRITICAL_ERROR:
			//
			// Critical errors mean we cannot rely on _ANY_ DB information being
			// available so we're going to dump out a simple echo'd statement
			//
			include($root_path . 'language/lang_english/lang_main.'.$phpEx);

			if ( $msg_text == '' )
			{
				$msg_text = $lang['A_critical_error'];
			}

			if ( $msg_title == '' )
			{
				$msg_title = 'Warning : <b>' . $lang['Critical_Error'] . '</b>';
			}
			break;
	}

	//
	// Add on DEBUG info if we've enabled debug mode and this is an error. This
	// prevents debug info being output for general messages should DEBUG be
	// set TRUE by accident (preventing confusion for the end user!)
	//

	if ( DEBUG && ( $msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR ) )
	{
		if ( $debug_text != '' )
		{
			$msg_text = $msg_text . '<br /><br /><b><u>DEBUG MODE</u></b>' . $debug_text;
		}
	}

	if ( $msg_code != CRITICAL_ERROR )
	{
		if ( !empty($lang[$msg_text]) )
		{
			$msg_text = $lang[$msg_text];
		}


		$core->template->assign_vars(array(
            'SIMPLE_TEXT' => $msg_title,
			'MESSAGE_TITLE' => $msg_title,
			'MESSAGE_TEXT' => $msg_text)
		);


		if ( !defined('IN_ADMIN')  )
		{
        	if ( $msg_code == GENERAL_ERROR || $msg_code == GENERAL_MESSAGE ) {
                $core->set_body_tmpls(array(
    	        	'message_body' => 'message_body.tpl'), '', TRUE	// clear all tmpls, but set this one
				);
				$core->page_render();
            }
            else if ( $msg_code == CRITICAL_MESSAGE )  {
            	$core->page_head_render();
                $core->template->set_filenames(array(
					'message_body' => 'message_body.tpl')
				);
                $core->template->pparse('message_body');
                $core->page_tail_render();

            }


		}
		else
		{
              	$core->template->set_filenames( array(
	                'message_body' => 'message_body.tpl'));
                $core->template->pparse('message_body');

			include($root_path . 'admin/page_footer_admin.'.$phpEx);
		}
	}
	else
	{
    	// on critical error
		echo "<html>\n<body>\n" . $msg_title . "\n<br /><br />\n" . $msg_text . "</body>\n</html>";
	}

	exit;
}

//
// This function is for compatibility with PHP 4.x's realpath()
// function.  In later versions of PHP, it needs to be called
// to do checks with some functions.  Older versions of PHP don't
// seem to need this, so we'll just return the original value.
// dougk_ff7 <October 5, 2002>

function ss_realpath($path)
{
	global $root_path, $phpEx;

	return (!@function_exists('realpath') || !@realpath($root_path . 'includes/functions.'.$phpEx)) ? $path : @realpath($path);
}

function redirect($url)
{
	global $db, $config;

	if (!empty($db))
	{
		$db->sql_close();
	}

	if (strstr(urldecode($url), "\n") || strstr(urldecode($url), "\r"))
	{
		message_die(GENERAL_ERROR, 'Tried to redirect to potentially insecure url.');
	}

    if (!preg_match('/^http:/',$url)) {
    
	    $server_protocol = ($config['cookie_secure']) ? 'https://' : 'http://';
	    $server_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($config['server_name']));
	    $server_port = ($config['server_port'] <> 80) ? ':' . trim($config['server_port']) : '';
	    $script_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($config['script_path']));
	    $script_name = ($script_name == '') ? $script_name : '/' . $script_name;

        // let redirect to same host
        $preg_value = '#^'.preg_quote($server_protocol).preg_quote($server_name).'#';
        if (!preg_match($preg_value,$url)) {
    	    $url = preg_replace('#^\/?(.*?)\/?$#', '/\1', trim($url));
        }
        else {
		    $url = preg_replace('#^\/?(.*?)\/?$#', '/\1', trim($url));
            $url = $server_protocol . $server_name . $server_port . $script_name . $url;
        }
    }
    
	// Behave as per HTTP/1.1 spec for others
	header('Location: ' . $url);
	exit;
}


//
// Part of bot MOD: This function checks whether the user agent or ip is
// listed as a bot and returns true otherwise false.
//
function is_robot()
{
	global $db, $HTTP_SERVER_VARS, $table_prefix;

	// define bots table - for the users who are to lazy to edit constants.php hehehe!
	define('BOTS_TABLE', $table_prefix . "bots");

	// get required user data
	$user_ip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	$user_agent = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];

	// get bot table data
	$sql = "SELECT bot_agent, bot_ip, bot_id, bot_visits, last_visit, bot_pages, bot_name
	FROM " . BOTS_TABLE;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain bot data.', '', __LINE__, __FILE__, $sql);
	}

	// loop through bots table
	while ($row = $db->sql_fetchrow($result))
	{
		// clear vars
		$agent_match = 0;
		$ip_match = 0;

		// check for user agent match
		foreach (explode('|', $row['bot_agent']) as $bot_agent)
		{
			if ($row['bot_agent'] && $bot_agent != '' && preg_match('#' . preg_quote($bot_agent, '#') . '#i', $user_agent)) $agent_match = 1;
		}

		// check for ip match
		foreach (explode('|', $row['bot_ip']) as $bot_ip)
		{
			if ($row['bot_ip'] && $bot_ip != '' && strpos($user_ip, $bot_ip) === 0)
			{
				$ip_match = 1;
				break;
			}
		}

		// if both ip and agent matched update table and return true
		if ($agent_match == 1 && $ip_match == 1)
		{
			// get time - seconds from epoch
			$today = time();

			$last_visits = explode('|', $row['last_visit']);

			// if half an hour has passed since last visit
			if (($today - (($last_visits[0] == '') ? 0 : $last_visits[0])) > 2700)
			{
				for ($i = ((4 > sizeof($last_visits)) ? sizeof($last_visits) : 4); $i >= 0; $i--)
				{
					if ($last_visits[$i-1] != '') $last_visits[$i] = $last_visits[$i-1];
				}

				// increment the new visit counter
				$row['bot_visits']++;

				// clear prior indexed pages
				$row['bot_pages'] = 1;
			} else {
				// add to indexed pages
				$row['bot_pages']++;
			}

			$last_visits[0] = $today;

			// compress it all together
			$last_visit = implode("|", $last_visits);

			// update table
			$sql = "UPDATE " . BOTS_TABLE . "
			SET last_visit='$last_visit', bot_visits='" . $row['bot_visits'] . "', bot_pages='" . $row['bot_pages'] . "'
			WHERE bot_id = " . $row['bot_id'];

			if ( !($result2 = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Couldn\'t update data in bots table.', '', __LINE__, __FILE__, $sql);
			}

			return $row['bot_name'];

		}
		else
		{
			if ($agent_match == 1 || $ip_match == 1)

			{

				// get data from table
				$sql = "SELECT pending_" . ((!$agent_match) ? 'agent' : 'ip') . "
				FROM " . BOTS_TABLE . "
				WHERE bot_id = " . $row['bot_id'];

				if ( !($result2 = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not obtain bot data.', '', __LINE__, __FILE__, $sql);
				}

				$row2 = $db->sql_fetchrow($result2);

				// add ip/agent to the list
				$pending_array = (( $row2['pending_' . ((!$agent_match) ? 'agent' : 'ip')] ) ? explode('|', $row2['pending_' . ((!$agent_match) ? 'agent' :  'ip')]) : array());

				$found = 0;

				if ( sizeof($pending_array) )
				{
					for ($loop = 0; $loop < count($pending_array); $loop+=2)
					{
						if ($pending_array[$loop] == ((!$agent_match) ? $user_agent : $user_ip)) $found = 1;
					}
				}

				if ($found == 0)
				{
					$pending_array[] = ((!$agent_match) ? str_replace("|", "&#124;", $user_agent) : $user_ip);
					$pending_array[] = ((!$agent_match) ? $user_ip : str_replace("|", "&#124;", $user_agent));
				}
				$pending = implode("|", $pending_array);

				// update table
				$sql = "UPDATE " . BOTS_TABLE . "
				SET pending_" . ((!$agent_match) ? 'agent' : 'ip') . "='$pending'
				WHERE bot_id = " . $row['bot_id'];

				if ( !($result2 = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Couldn\'t update data in bots table.', '', __LINE__, __FILE__, $sql);
				}
			}
		}

	}

	return 0;
}

/*
	Create random id
*/

function ss_generate_rid() {

/*
		list($sec, $usec) = explode(' ', microtime());
		mt_srand((float) $sec + ((float) $usec * 100000));
		$rid = 'z' . md5(uniqid(mt_rand(), true));
*/
		$rid = uniqid('z');
        return $rid;

}

/*
  	s
*/

function ss_serialize($v, $d = 0) {



   $ret = serialize($v);
   //$ret = var_export($v,TRUE);
   //if ($d) $ret = base64_encode($ret);

   return $ret;
}

/*
	s
*/

function ss_unserialize($v, $d = 0) {

	if ($d) $ret = base64_decode($v); else $ret=$v;
    //$eval_sz = '$ret = ' . $ret . ';';
    //print $eval_sz;
    //eval( $eval_sz );

     $ret = unserialize(stripslashes($v));
	//$ret = unserialize($ret);
	return $ret;
}

// pack arrays

function ss_unpack_array($v) {
	if (empty($v)) return NULL;
	$ret = array();
    $eval_sz = '$ret = ' . base64_decode($v) . ';';
    @eval( $eval_sz );
    //var_dump( $eval_sz);
    return $ret;

}

/*
	do strip_slashes before past vars to THIS POINT
*/

function ss_pack_array($v) {

   $ret = var_export($v,TRUE);
   //$ret =  stripslashes($ret);
   //var_dump( $ret);
   $ret = base64_encode($ret);
   return $ret;
}

//
// fix paths
//

function ss_fix_path ( $path, $is_url = FALSE ) {

	if (empty($path)) return '';

	$core = core_c::get_instance();

	if (substr($path,strlen($path)-1,1)!='/') $path .= '/';

	//this path are not absolute, so
	if (strpos($path,':')===FALSE && $path{0}!=='/' && !$is_url) {
		$path = $core->config['site_path'] . $path;
	}

	if ($is_url && !preg_match('/^http:\/\//',$path)) $path = $core->config['self_url'] . $path;

	return $path;
}

/*
    translit
*/

function skillz_translit($s)    {
    $s=strtr($s,"","ABVGDEZIJKLMNOPRSTUFC\"Y'abvgdezijklmnoprstufc\"y'");
    $doit=array(' '=>'_', ''=>'JO',''=>'ZH',''=>'KH',''=>'CH',''=>'SH',''=>'SHCH',''=>'EH',''=>'JU',''=>'JA',''=>'jo',''=>'zh',''=>'kh',''=>'ch',''=>'sh',''=>'shch',''=>'eh',''=>'ju',''=>'ja');
    $s=strtr($s,$doit);
    $s = preg_replace('~[^\w\d_]~i','',$s);
    return $s;
}

?>